package asd.td8;

import asd.graphe.Adjacents;
import asd.graphe.GrapheOriente;

/**
 * EXERCICE 1 - TD 8
 * Une classe pour chercher si un graphe orient admet un puits.
 */
public class Puits {

    private GrapheOriente G;

    /**
     * Construit un objet Puits pour la dterminer si le graphe possde
     * un puits.
     */
    public Puits(GrapheOriente G) {
	this.G  = G;
    }

    /**
     * Retourne le sommet p si p est un puits de G, ou -1 si G n'admet pas
     * de puits.
     * Complexit : O(S + A) o S est l'ordre du graphe et A le nombre d'arcs.
     */
    public int puits() {
        int[] de = new int[G.ordre()];
        int[] ds = new int[G.ordre()];

	for ( int i = 0; i < G.ordre(); i++ ) {
            Adjacents adj = G.adjacents(i);

            // pour mettre  jour les degrs entrant et sortant
            while ( adj.nonVide() ) {
                de[adj.suivant()]++;
                ds[i]++;
            }
	}

        for ( int i = 0; i < G.ordre(); i++ ) {
            if ( de[i] == G.ordre() - 1 ) {
                if ( ds[i] == 0 ) {
                    return i;
                }
                return -1;
            }
        }
        return -1;
    }
}
